commit 432276e49d4b5dcbad80f023b7525c5571c43075
Author: Katja Luther <k.luther@bgbm.org>
Date:   Tue Nov 20 12:51:08 2018 +0100

    ref #7849: harmonize admin and local preferences for distribution editor and use drop down instead of radio buttons

diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/ChecklistLabelProvider.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/ChecklistLabelProvider.java
index 4c7afbcff..3ba5dc44b 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/ChecklistLabelProvider.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/ChecklistLabelProvider.java
@@ -43,6 +43,7 @@ import eu.etaxonomy.cdm.model.name.TaxonName;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.taxeditor.editor.view.checklist.e4.ChecklistEditorE4;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
+import eu.etaxonomy.taxeditor.preference.TermDisplayEnum;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 
 /**
@@ -125,10 +126,20 @@ public class ChecklistLabelProvider extends LabelProvider implements ITableLabel
                                 String label = rep.getLabel();
 
                                 if (label == null){
-                                    distribution.getStatus().getTitleCache();
+                                    label = distribution.getStatus().getTitleCache();
                                 }
-                                if (PreferencesUtil.isShowSymbolInChecklistEditor()){
-                                    return (StringUtils.isNotBlank(distribution.getStatus().getSymbol() ))?distribution.getStatus().getSymbol():label;
+                                if (PreferencesUtil.displayStatusInChecklistEditor() != null){
+                                    if(PreferencesUtil.displayStatusInChecklistEditor().equals(TermDisplayEnum.IdInVocabulary.getKey())){
+                                        return (StringUtils.isNotBlank(distribution.getStatus().getIdInVocabulary()))?distribution.getStatus().getIdInVocabulary():label;
+                                    }else if(PreferencesUtil.displayStatusInChecklistEditor().equals(TermDisplayEnum.Symbol1.getKey())){
+                                        System.err.println(columnIndex + " " +label);
+                                        return (StringUtils.isNotBlank(distribution.getStatus().getSymbol() ))?distribution.getStatus().getSymbol():label;
+                                    }else if(PreferencesUtil.displayStatusInChecklistEditor().equals(TermDisplayEnum.Symbol2.getKey())){
+                                        return (StringUtils.isNotBlank(distribution.getStatus().getSymbol2() ))?distribution.getStatus().getSymbol2():label;
+                                    }else{
+                                        return (label != null)?label:DEFAULT_ENTRY;
+                                    }
+
                                 }else{
                                     return (label != null)?label:DEFAULT_ENTRY;
                                 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/DistributionEditingSupportE4.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/DistributionEditingSupportE4.java
index 37614d6a5..282f98f6d 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/DistributionEditingSupportE4.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/DistributionEditingSupportE4.java
@@ -43,6 +43,7 @@ import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.taxeditor.event.EventUtility;
 import eu.etaxonomy.taxeditor.event.WorkbenchEventConstants;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
+import eu.etaxonomy.taxeditor.preference.TermDisplayEnum;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 
 public final class DistributionEditingSupportE4 extends EditingSupport {
@@ -82,11 +83,27 @@ public final class DistributionEditingSupportE4 extends EditingSupport {
         	    	     label = status.getTitleCache();
         	    	 }
         	    	 String result = null;
-        	    	 if (PreferencesUtil.isShowSymbolInChecklistEditor() && !StringUtils.isBlank(status.getSymbol())){
-        	    		 result = label + "("+ status.getSymbol()+")";
+        	    	 String statusDisplay = PreferencesUtil.displayStatusInChecklistEditor();
+        	    	 if (statusDisplay != null){
+        	    	     if (statusDisplay.equals(TermDisplayEnum.Symbol1.getKey()) && !StringUtils.isBlank(status.getSymbol())){
+        	    	         result = label + "("+ status.getSymbol()+")";
+        	    	     }else if (statusDisplay.equals(TermDisplayEnum.IdInVocabulary.getKey()) && !StringUtils.isBlank(status.getIdInVocabulary())){
+        	    	         result = label + "("+ status.getIdInVocabulary()+")";
+        	    	     }else if (statusDisplay.equals(TermDisplayEnum.Symbol2.getKey()) && !StringUtils.isBlank(status.getSymbol2())){
+                             result = label + "("+ status.getSymbol2()+")";
+                         }else{
+        	    	         result = label;
+        	    	     }
+
         	    	 }else{
-        	    		 result = label;
+        	    	     result = label;
         	    	 }
+//
+//        	    	 if (PreferencesUtil.displayStatusInChecklistEditor() != null && !StringUtils.isBlank(status.getSymbol())){
+//        	    		 result = label + "("+ status.getSymbol()+")";
+//        	    	 }else{
+//        	    		 result = label;
+//        	    	 }
         	    	 return result;
         	     }
         	     return null;
@@ -168,7 +185,7 @@ public final class DistributionEditingSupportE4 extends EditingSupport {
                     descr.removeElement(distribution);
                     changed = true;
                 }else{
-                    if (!distribution.getStatus().equals(occurenceStatus)){
+                    if (distribution.getStatus() == null || !distribution.getStatus().equals(occurenceStatus)){
                         changed = true;
                         distribution.setStatus(occurenceStatus);
                     }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/handler/OpenChecklistEditorHandlerE4.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/handler/OpenChecklistEditorHandlerE4.java
index 56a20fe72..6dce69634 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/handler/OpenChecklistEditorHandlerE4.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/handler/OpenChecklistEditorHandlerE4.java
@@ -2,7 +2,10 @@ package eu.etaxonomy.taxeditor.editor.view.checklist.e4.handler;
 
 import java.util.UUID;
 
+import javax.inject.Inject;
+
 import org.apache.commons.lang.StringUtils;
+import org.eclipse.e4.core.services.log.Logger;
 import org.eclipse.e4.ui.model.application.ui.basic.MPart;
 import org.eclipse.e4.ui.model.application.ui.basic.MPartStack;
 import org.eclipse.e4.ui.workbench.modeling.EPartService;
@@ -26,7 +29,8 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.workbench.WorkbenchUtility;
 
 public class OpenChecklistEditorHandlerE4 extends DefaultOpenHandlerBaseE4<ITaxonTreeNode> {
-
+    @Inject
+    private Logger logger;
     private static final String COULD_NOT_OPEN_DISTRIBUTION_EDITOR_THE_HIERARCHY_IS_CORRUPTED = Messages.OpenChecklistEditorHandler_COULD_NOT_OPEN_MESSAGE;
     private static final String COULD_NOT_OPEN_DISTRIBUTION_EDITOR = Messages.OpenChecklistEditorHandler_COULD_NOT_OPEN_TITLE;
 
@@ -80,7 +84,7 @@ public class OpenChecklistEditorHandlerE4 extends DefaultOpenHandlerBaseE4<ITaxo
 		if (checklistEditor != null){
 			checklistEditor.init(input);
 		}else{
-			System.err.println("Editor is null");
+			logger.debug("Editor is null");
 		}
 	}
 
diff --git a/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TaxonNavigatorE4.java b/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TaxonNavigatorE4.java
index 9c7854d55..668c88ecc 100644
--- a/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TaxonNavigatorE4.java
+++ b/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TaxonNavigatorE4.java
@@ -90,6 +90,7 @@ import eu.etaxonomy.taxeditor.navigation.navigator.EmptyRoot;
 import eu.etaxonomy.taxeditor.navigation.navigator.Root;
 import eu.etaxonomy.taxeditor.navigation.navigator.TaxonNodeNavigatorComparator;
 import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
+import eu.etaxonomy.taxeditor.preference.NavigatorOrderEnum;
 import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySession;
 import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
@@ -218,9 +219,10 @@ public class TaxonNavigatorE4 implements
 	/** {@inheritDoc} */
 	protected IAdaptable getInitialInput() {
 		Comparator<TaxonNodeDto> comparator;
-		if (PreferencesUtil.getSortNodesNaturally()){
+		NavigatorOrderEnum orderValue = PreferencesUtil.getSortNodes();
+		if (orderValue.equals(NavigatorOrderEnum.NaturalOrder)){
 			comparator = new TaxonNodeDtoNaturalComparator();
-		} else if (PreferencesUtil.getSortNodesStrictlyAlphabetically()){
+		} else if (orderValue.equals(NavigatorOrderEnum.AlphabeticalOrder)){
 			comparator = new TaxonNodeDtoByNameComparator();
 		}else {
 			comparator = new TaxonNodeDtoByRankAndNameComparator();
diff --git a/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TreeNodeDropAdapterE4.java b/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TreeNodeDropAdapterE4.java
index 13d21c5d4..f97aee934 100644
--- a/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TreeNodeDropAdapterE4.java
+++ b/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/TreeNodeDropAdapterE4.java
@@ -9,9 +9,11 @@
 
 package eu.etaxonomy.taxeditor.navigation.navigator.e4;
 
+import java.util.ArrayList;
 import java.util.EnumSet;
 import java.util.HashSet;
 import java.util.Iterator;
+import java.util.List;
 import java.util.Set;
 import java.util.UUID;
 
@@ -143,6 +145,9 @@ public class TreeNodeDropAdapterE4 extends ViewerDropAdapter implements IPostMon
 
 		    // do not allow to drop onto itself and
 		    // check users permissions with all selected taxon nodes and taxa
+		    List<UUID> nodeUuids = new ArrayList<>();
+		    boolean isNotSameTaxonNode = true;
+		    boolean isNotSameParent = true;
 		    for(TaxonNodeDto taxonNode : getSelectedTaxa()){
 			    if (logger.isDebugEnabled()){
 			    	logger.debug("selectedTaxa: " + taxonNode.getTaxonUuid() == null? "-" : taxonNode.getTitleCache()); //$NON-NLS-1$
@@ -154,30 +159,35 @@ public class TreeNodeDropAdapterE4 extends ViewerDropAdapter implements IPostMon
 	                    }
 	                    return false;
 	                }
-			    boolean isSameTaxonNode = taxonNode.equals(target);
-			    boolean isSameParent = taxonNode.getParentUUID().equals(((TaxonNodeDto) target).getUuid());
-			    TaxonNode node = CdmStore.getService(ITaxonNodeService.class).load(taxonNode.getUuid());
-				boolean hasTaxonNodePermission = CdmStore.currentAuthentiationHasPermission(node, UPDATE);
+			    isNotSameTaxonNode = isNotSameTaxonNode && !taxonNode.equals(target);
+			    isNotSameParent = isNotSameParent && !taxonNode.getParentUUID().equals(((TaxonNodeDto) target).getUuid());
+			    nodeUuids.add(taxonNode.getUuid());
 
-				boolean hasTaxonPermission =
-	        			CdmStore.currentAuthentiationHasPermission(node.getTaxon(), UPDATE);CdmStore.currentAuthentiationHasPermission(node.getTaxon(), UPDATE);
+		    }
+			    List<TaxonNode> nodes = CdmStore.getService(ITaxonNodeService.class).load(nodeUuids, null);
+			    boolean hasPermission = true;
+			    for (TaxonNode node: nodes){
+			        hasPermission = hasPermission && CdmStore.currentAuthentiationHasPermission(node, UPDATE) && CdmStore.currentAuthentiationHasPermission(node.getTaxon(), UPDATE);
+			    }
+//				boolean hasTaxonPermission =
+//	        			CdmStore.currentAuthentiationHasPermission(node.getTaxon(), UPDATE);
                 if (
-			        isSameTaxonNode
-			        || isSameParent
-			        || !hasTaxonNodePermission
-    	            || !hasTaxonPermission
+			        !isNotSameTaxonNode
+			        || !isNotSameParent
+			        || !hasPermission
+
     	            ) {
                     if(logger.isDebugEnabled()){
-                        logger.debug("CANCEL_STATUS for selected  " + isSameTaxonNode + Messages.TreeNodeDropAdapter_10 + hasTaxonNodePermission + " " + hasTaxonPermission + " "); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+                        logger.debug("CANCEL_STATUS for selected  " + isNotSameTaxonNode + Messages.TreeNodeDropAdapter_10 + hasPermission +  " "); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
                     }
 					return false;
 				}
 			}
 			logger.debug("OK_STATUS"); //$NON-NLS-1$
 			return true;
-		}
-		logger.debug("CANCEL_STATUS"); //$NON-NLS-1$
-		return false;
+//		}
+//		logger.debug("CANCEL_STATUS"); //$NON-NLS-1$
+//		return false;
 	}
 
 
@@ -191,7 +201,7 @@ public class TreeNodeDropAdapterE4 extends ViewerDropAdapter implements IPostMon
         }
         IUndoContext workspaceUndoContext = taxonNavigator.getUndoContext();
          int movingTypeInt = 0;
-		if (PreferencesUtil.getSortNodesNaturally()){
+		if (PreferencesUtil.isNodesSortedNaturally()){
 			String[] buttonLables = {TREE_NODE_DROP_ADAPTER_CHILD, TREE_NODE_DROP_ADAPTER_BEHIND,TREE_NODE_DROP_ADAPTER_CANCEL};
 			MessageDialog dialog = new MessageDialog(null, TARGET_NODE, null, DO_YOU_WANT_TO_MOVE_THE_TAXONNODE_AS_CHILD_OR_BEHIND_THE_TARGET_NODE, MessageDialog.QUESTION_WITH_CANCEL, buttonLables, 0);
 			dialog.open();
@@ -233,7 +243,7 @@ public class TreeNodeDropAdapterE4 extends ViewerDropAdapter implements IPostMon
             public void run() {
                 AbstractUtility.executeMoniteredOperation("Move Taxon to new parent: ",
                         uuid,
-                        500,
+                        1000,
                         false,
                         TreeNodeDropAdapterE4.this,
                         null,
diff --git a/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/handler/RemotingMoveTaxonNodeHandlerE4.java b/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/handler/RemotingMoveTaxonNodeHandlerE4.java
index 675cf8fec..33d27900b 100644
--- a/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/handler/RemotingMoveTaxonNodeHandlerE4.java
+++ b/eu.etaxonomy.taxeditor.navigation/src/main/java/eu/etaxonomy/taxeditor/navigation/navigator/e4/handler/RemotingMoveTaxonNodeHandlerE4.java
@@ -94,9 +94,7 @@ public class RemotingMoveTaxonNodeHandlerE4 extends RemotingCdmHandlerE4 {
         TaxonNode parentTaxonNode;
         MovingType moveToNewParent = MovingType.CHILD;
 
-        if (PreferencesUtil.getSortNodesNaturally()){
-
-
+        if (PreferencesUtil.isNodesSortedNaturally()){
             parentTaxonNode = TaxonNodeSelectionDialog.select(shell,
                     Messages.RemotingMoveTaxonNodeHandler_CHOOSE_TAXON,
                     oldTaxonNodeUUIDs,
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/AbcdImportPreference.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/AbcdImportPreference.java
index 09ac66ab1..b0cc55f32 100755
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/AbcdImportPreference.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/preferencePage/AbcdImportPreference.java
@@ -25,10 +25,11 @@ import eu.etaxonomy.cdm.api.service.IPreferenceService;
 import eu.etaxonomy.cdm.io.specimen.abcd206.in.Abcd206ImportConfigurator;
 import eu.etaxonomy.cdm.model.metadata.CdmPreference;
 import eu.etaxonomy.cdm.model.metadata.CdmPreference.PrefKey;
-import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
 import eu.etaxonomy.cdm.model.metadata.PreferenceSubject;
 import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
 import eu.etaxonomy.taxeditor.l10n.Messages;
+import eu.etaxonomy.taxeditor.preference.EditorPreferencePredicate;
+import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
 import eu.etaxonomy.taxeditor.preference.menu.CdmPreferencePage;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 
@@ -55,7 +56,7 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
         configurator = Abcd206ImportConfigurator.NewInstance(null,null);
         ICdmRepository controller;
         controller = CdmStore.getCurrentApplicationConfiguration();
-        PrefKey key = CdmPreference.NewKey(PreferenceSubject.NewTaxEditorInstance(), PreferencePredicate.AbcdImportConfig);
+        PrefKey key = CdmPreference.NewKey(PreferenceSubject.NewTaxEditorInstance(), EditorPreferencePredicate.AbcdImportConfig);
 
         if (controller == null){
             return null;
@@ -65,7 +66,7 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
         if (preference != null ){
             allowOverride = preference.isAllowOverride();
         }else{
-            preference = CdmPreference.NewTaxEditorInstance(PreferencePredicate.AbcdImportConfig, configurator.toString());
+            preference = CdmPreference.NewTaxEditorInstance(EditorPreferencePredicate.AbcdImportConfig, configurator.toString());
         }
 
         if (preference != null){
@@ -110,7 +111,12 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
                      configurator.setOverwriteExistingSpecimens(Boolean.valueOf(valueString));
                  }else if (keyString.equals("nomenclaturalCode")){ //$NON-NLS-1$
                      configurator.setNomenclaturalCode(NomenclaturalCode.fromString(valueString));
+                 }else if (keyString.equals("getSiblings")){ //$NON-NLS-1$
+                     configurator.setGetSiblings(Boolean.valueOf(valueString));
+                 }else if (keyString.equals("removeCountryFromLocalityText")){ //$NON-NLS-1$
+                     configurator.setRemoveCountryFromLocalityText(Boolean.valueOf(valueString));
                  }
+
              }
 
          }
@@ -224,7 +230,7 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
         checkBoxImportSiblings.addSelectionListener(new SelectionAdapter() {
             @Override
             public void widgetSelected(SelectionEvent e) {
-                configurator.setGetSiblings(checkBoxImportSiblings.getSelection());
+                configurator.setGetSiblings(!configurator.isGetSiblings());
             }
         });
 
@@ -260,7 +266,7 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
         checkBoxReuseExistingTaxa.addSelectionListener(new SelectionAdapter() {
             @Override
             public void widgetSelected(SelectionEvent e) {
-                configurator.setReuseExistingDescriptiveGroups(!configurator.isReuseExistingDescriptiveGroups());
+                configurator.setReuseExistingTaxaWhenPossible(!configurator.isReuseExistingTaxaWhenPossible());
             }
         });
 
@@ -318,7 +324,7 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
         if (configurator != null){
             String configString = configurator.toString();
 
-            CdmPreference pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.AbcdImportConfig, configString);
+            CdmPreference pref = CdmPreference.NewTaxEditorInstance(EditorPreferencePredicate.AbcdImportConfig, configString);
             pref.setAllowOverride(allowOverride);
 
             ICdmRepository controller = CdmStore.getCurrentApplicationConfiguration();
@@ -327,6 +333,7 @@ public class AbcdImportPreference extends CdmPreferencePage implements IE4AdminP
             }
             IPreferenceService service = controller.getPreferenceService();
             service.set(pref);
+            PreferencesUtil.updateDBPreferences();
 
         }
         return true;
